#pragma once

#include "mpxhw.h"
#include <vector>
#include <string>


class HwDummy
{
public:
    static double getPreciseTime();

public:
    HwDummy(int hwID);
    virtual ~HwDummy();

    int reinit();
    int initData();
    int getHwInfo(int index, HwInfoItem *hwInfo, int *dataSize);
    int getHwInfoFlags(int index, u32 *flags);
    int setHwInfo(int index, void *data, int dataSize);
    int getDevInfo(DevInfo *devInfo);
    int getAcqTime(double *time)        {*time = elapsedTime; return 0;}
    int setAcqPars(AcqParams *pars);
    int startAcquisition();
    int stopAcquisition();
    int testPulses(double pulseHeight, double period, u32 pulseCount);
    int setMpxDACs(DACTYPE dacVals[], int size, byte senseChip, byte extDacChip, int codes[], u32 tpReg);
    int getMpxDacVal(int chipNumber, double *value);
    int setPixelsCfg(byte cfgs[]);
    int resetMatrix();
    int readMatrix(i16 *buff, u32 buffSize);
    int writeMatrix(i16 *buff, u32 buffSize);
    int generalReset();
    int checkBusy(BOOL *busy);
    const char *getLastErrStr()         {return lastErrStr;}

protected:
    void initHwInfoItems();
    int initImage();
    int getImageFileDir(i16 *buff, u32 buffSize);
    int getImageFileSerie(int i, i16 *buff, u32 buffSize, bool forceRead = false);
    int readImageFile(const char *fileName, u32 fileFormat, i16 *buff, u32 buffSize);

public:
    static const int hwItemCount = 3;

private:
    int id;
    DevInfo devInfo;
    AcqParams acqPars;
    HwCallback callback;

    u32 version;                            // dumy hw version
    BOOL addNoise;                          // noise will be added to frame
    
    double startTime;                       // start time of acq
    double elapsedTime;                     // elapsed time of acq
    i16 *imageData;                         // last acq image
    char imageFileName[MPX_MAX_PATH];       // base data file name (without index)

    char lastErrStr[MPXCTRL_MAX_MSGLENGTH]; // last error (string)
    HwInfoItem hwInfoItems[hwItemCount];    // hw specific items
};

