// mpxHwDummy.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "mpxhwdummy.h"
#include <cstdio> 

using namespace std;

MpxHwDummyMgr MpxHwDummyMgr::devMgr;
MpxHwDummyMgr &devMgr = MpxHwDummyMgr::devMgr;


BOOL APIENTRY DllMain( HANDLE hModule, 
                      DWORD  ul_reason_for_call, 
                      LPVOID lpReserved
                      )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
        hInstance = (HINSTANCE) hModule;
        devMgr.init();
        break;

    case DLL_THREAD_ATTACH:
        break;

    case DLL_THREAD_DETACH:
        break;

    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}

HMODULE hInstance;

MpxHwDummyMgr::MpxHwDummyMgr()
    : devCount(0)
    , curIter(0)
    , globalLastErr(0)
{
    iniFileName[0] = '\0';
}

MpxHwDummyMgr::~MpxHwDummyMgr()
{
    for (unsigned i = 0; i < devices.size(); i++)
        delete devices[i];
};

int MpxHwDummyMgr::init()
{
    if (!GetModuleFileName(hInstance, iniFileName, MPX_MAX_PATH))
        return 0;
    char *slash = strrchr(iniFileName, '\\');
    char *dot = strrchr(iniFileName, '.');
    if (dot < slash || dot == 0)
        strcat(iniFileName, ".ini");
    else
        strcpy(dot, ".ini");

    readIni();
    writeIni();
    return 0;
}

void MpxHwDummyMgr::readIni()
{
    devCount = GetPrivateProfileInt("Dummy", "Count", 1, iniFileName);
}

void MpxHwDummyMgr::writeIni()
{
    char str[32] = "";
    WritePrivateProfileString("Dummy", "Count", _itoa(devCount, str, 10), iniFileName);
}

int MpxHwDummyMgr::getFirst(int *hwID)
{
    readIni();
    curIter = 0;
    if (devCount > (int) devices.size())
    {
        for (int i = (int) devices.size(); i < devCount; i++)
        {
            HwDummy *dummy = new HwDummy(i);
            devices.push_back(dummy);
        }
    }
    if (devices.size() > 0)
    {
        *hwID = 0;
        return 0;
    }
    else
        return 1;
}

int MpxHwDummyMgr::getNext(int *hwID)
{
    curIter++;
    if (curIter < (int) devices.size())
    {
        *hwID = curIter;
        return 0;
    }
    else
        return 1;
}

HwDummy *  MpxHwDummyMgr::getDevice(int hwID)
{
    if ((u32) hwID < devices.size())
        return  devices[hwID];
    globalLastErrStr = "Invalid HW ID";
    globalLastErr = MPXERR_INVALID_PARVAL;
    return 0;
}

int MpxHwDummyMgr::getDefImageFileName(char *fileName)
{
    strcpy(fileName, iniFileName);
    char *bslash = strrchr(fileName, '\\');
    if (bslash)
        strcpy(bslash, "\\dummy.txt");
    return 0;
}
