#pragma once

#include "mpxhw.h"
#include "hwdummy.h"

class MpxHwDummyMgr
{
public:
    static MpxHwDummyMgr devMgr;
    virtual ~MpxHwDummyMgr();
    int init();
    int getFirst(int *hwID);
    int getNext(int *hwID);
    HwDummy * getDevice(int hwID);
    int getLastErr()                    {return globalLastErr;}
    const char* getLastErrStr()         {return globalLastErrStr;}
    int getDefImageFileName(char *fileName);

protected:
    void readIni();
    void writeIni();

private:
    MpxHwDummyMgr();
    MpxHwDummyMgr(MpxHwDummyMgr &);
    MpxHwDummyMgr & operator=(MpxHwDummyMgr &);

private:
    std::vector<HwDummy *> devices;
    char iniFileName[MPX_MAX_PATH];
    int devCount;
    int curIter;
    int globalLastErr;
    const char *globalLastErrStr;
};

extern MpxHwDummyMgr &devMgr;
extern HMODULE hInstance;
