#include "stdafx.h"
#include <cstdlib>
#include <ctime>
#include "mpxhwdummyapi.h"
#include "mpxhwdummy.h"

MpxHwFuncs mpxHwFuncs = 
{
    sizeof(MpxHwFuncs),
    hwGetFirst,
    hwGetNext,
    hwInit,
    hwSetCb,
    hwSetCbTag,
    hwGetHwInfoCount,
    hwGetHwInfoFlags,
    hwGetHwInfo,
    hwSetHwInfo,
    hwGetDevInfo,
    hwGetAcqTime,
    hwSetAcqPars,
    hwStartAcquisition,
    hwStopAcquisition,
    hwTestPulses,
    hwSetMpxDACs,
    hwGetMpxDacVal,
    hwSetExtDac,
    hwSetPixelsCfg,
    hwResetMatrix,
    hwReadMatrix,
    hwWriteMatrix,
    hwGeneralReset,
    hwGetGlobalLastError,
    hwGetLastError,
    hwCheckBusy,
    hwCloseDevice,
};

MPXHWDUMMY_API MpxHwFuncs* getMandatoryFuncs()
{
    return &mpxHwFuncs;
}

int hwGetFirst(int *hwID)
{
    return devMgr.getFirst(hwID);
}

int hwGetNext(int *hwID)
{
    return devMgr.getNext(hwID);
}

#define GETDEVICE(hwID)\
    HwDummy *hw = devMgr.getDevice(hwID);\
    if (!hw)\
        return devMgr.getLastErr();


int hwInit(int hwID)
{
    GETDEVICE(hwID);
    return hw->reinit();
}

int hwGetHwInfo(int hwID, int index, HwInfoItem *hwInfo, int *dataSize)
{
    GETDEVICE(hwID);
    return hw->getHwInfo(index, hwInfo, dataSize);
}

int hwGetHwInfoCount()
{
    return HwDummy::hwItemCount;
}

int hwGetHwInfoFlags(int hwID, int index, u32 *flags)
{
    GETDEVICE(hwID);
    return hw->getHwInfoFlags(index, flags);
}

int hwSetHwInfo(int hwID, int index, void *data, int dataSize)
{
    GETDEVICE(hwID);
    return hw->setHwInfo(index, data, dataSize);
}


int hwSetCb(HwCallback callback)
{
    return 0;
}

int hwSetCbTag(int hwID, TAGTYPE tag)
{
    return 0;
}

int hwGetDevInfo(int hwID, DevInfo *devInfo)
{
    GETDEVICE(hwID);
    return hw->getDevInfo(devInfo);
}

int hwGetAcqTime(int hwID, double *time)
{
    GETDEVICE(hwID);
    return hw->getAcqTime(time);
}

int hwSetAcqPars(int hwID, AcqParams *pars)
{
    GETDEVICE(hwID);
    return hw->setAcqPars(pars);
}

int hwStartAcquisition(int hwID)
{
    GETDEVICE(hwID);
    return hw->startAcquisition();
}

int hwStopAcquisition(int hwID)
{
    GETDEVICE(hwID);
    return hw->stopAcquisition();
}

int hwTestPulses(int hwID, double pulseHeight, double period, u32 pulseCount)
{
    GETDEVICE(hwID);
    return hw->testPulses(pulseHeight, period, pulseCount);
}

int hwSetMpxDACs(int hwID, DACTYPE dacVals[], int size, byte senseChip, byte extDacChip, int codes[], u32 tpReg)
{
    GETDEVICE(hwID);
    return hw->setMpxDACs(dacVals, size, senseChip, extDacChip, codes, tpReg);
}

int hwGetMpxDacVal(int hwID, int chipNumber, double *value)
{
    GETDEVICE(hwID);
    return hw->getMpxDacVal(chipNumber, value);
}

int hwSetExtDac(int hwID, double value)
{
    GETDEVICE(hwID);
    return 0;
}

int hwSetPixelsCfg(int hwID, byte cfgs[], u32 size)
{
    GETDEVICE(hwID);
    return hw->setPixelsCfg(cfgs);
}

int hwResetMatrix(int hwID)
{
    GETDEVICE(hwID);
    return hw->resetMatrix();
}

int hwReadMatrix(int hwID, i16 *buff, u32 buffSize)
{
    GETDEVICE(hwID);
    return hw->readMatrix(buff, buffSize);
}

int hwWriteMatrix(int hwID, i16 *buff, u32 buffSize)
{
    GETDEVICE(hwID);
    return hw->writeMatrix(buff, buffSize);
}

int hwGeneralReset(int hwID)
{
    GETDEVICE(hwID);
    return hw->generalReset();
}

int hwCheckBusy(int hwID, BOOL *busy)
{
    GETDEVICE(hwID);
    return hw->checkBusy(busy);
}

const char* hwGetGlobalLastError()
{
    return devMgr.getLastErrStr();
}

const char* hwGetLastError(int hwID)
{
    HwDummy *hw = devMgr.getDevice(hwID);
    return hw ? hw->getLastErrStr() : devMgr.getLastErrStr();
}

int hwCloseDevice(int hwID)
{
    return 0;
}
