#pragma once

#include "mpxhw.h"

#ifdef MPXHWDUMMY_EXPORTS
    #define MPXHWDUMMY_API __declspec(dllexport)
#else
    #define MPXHWDUMMY_API __declspec(dllimport)
#endif

extern "C"
{
    MPXHWDUMMY_API MpxHwFuncs* getMandatoryFuncs();
}

int hwGetFirst(int *hwID);
int hwGetNext(int *hwID);
int hwInit(int hwID);
int hwGetHwInfoCount();
int hwGetHwInfoFlags(int hwID, int index, u32 *flags);
int hwGetHwInfo(int hwID, int index, HwInfoItem *hwInfo, int *dataSize);
int hwSetHwInfo(int hwID, int index, void *data, int dataSize);
int hwSetCb(HwCallback callback);
int hwSetCbTag(int hwID, TAGTYPE tag);
int hwGetDevInfo(int hwID, DevInfo *devInfo);
int hwGetAcqTime(int hwID, double *time);
int hwSetAcqPars(int hwID, AcqParams *pars);
int hwStartAcquisition(int hwID);
int hwStopAcquisition(int hwID);
int hwTestPulses(int hwID, double pulseHeight, double period, u32 pulseCount);
int hwSetMpxDACs(int hwID, DACTYPE dacVals[], int size, byte senseChip, byte extDacChip, int codes[], u32 tpReg);
int hwGetMpxDacVal(int hwID, int chipNumber, double *value);
int hwSetExtDac(int hwID, double value);
int hwSetPixelsCfg(int hwID, byte cfgs[], u32 size);
int hwResetMatrix(int hwID);
int hwReadMatrix(int hwID, i16 *buff, u32 buffSize);
int hwWriteMatrix(int hwID, i16 *buff, u32 buffSize);
int hwGeneralReset(int hwID);
const char* hwGetGlobalLastError();
const char* hwGetLastError(int hwID);
int hwCheckBusy(int hwID, BOOL *busy);
int hwCloseDevice(int hwID);
